#!/usr/local/bin/tclsh

set Usage  "Usage: $argv0 \[ -a | -b \] \[ -o <string> \]"

#parsing the commanline using getopt    

##the getopt source code
#set optind 0
#set optindc 0
#
#proc getopt { argslist optstring optret argret } {
#  global optind optindc
#  upvar $optret retvar
#  upvar $argret optarg
#
## default settings for a normal return
#  set optarg ""
#  set retvar ""
#  set retval 0
#
## check if we're past the end of the args list
#  if { $optind < [ llength $argslist ] } then {
#
## if we got -- or an option that doesn't begin with -, return (skipping
## the --).  otherwise process the option arg.
#    switch -glob -- [ set arg [ lindex $argslist $optind ]] {
#      "--" {
#        incr optind
#      }
#
#      "-*" {
#        if { $optindc < 1 } then {
#          set optindc 1
#        }
#
#        set opt [ string index $arg $optindc ]
#
#        if { [ incr optindc ] == [ string length $arg ] } then {
#          set arg [ lindex $argslist [ incr optind ]]
#          set optindc 0
#        }
#
#        if { [ string match "*$opt*" $optstring ] } then {
#          set retvar $opt
#          set retval 1
#          if { [ string match "*$opt:*" $optstring ] } then {
#            if { $optind < [ llength $argslist ] } then {
#              set optarg [ string range $arg $optindc end ]
#              incr optind
#              set optindc 0
#            } else {
#              set optarg "Option requires an argument -- $opt"
#              set retvar $optarg
#              set retval -1
#            }
#          }
#        } else {
#          set optarg "Illegal option -- $opt"
#          set retvar $optarg
#          set retval -1
#        }
#      }
#    }
#  }
#
#  return $retval
#}

# the example of using getopt

package require getopt 1.0

set found(a) 0
set found(b) 0
set found(o) ""

proc usage {} {
	global Usage
	puts stderr $Usage
	exit 2
}

while { [ set err [ getopt $argv "abo:" opt arg ]] } {
	if { $err < 0 } then {
		puts stderr "$argv0: $arg"
		usage

	} else {
		switch -exact $opt {
			a {
				if { $found(b) } then {
               puts stderr "$argv0: Only one of -a and -b may be specified!"
               usage
				} else {
               set found(a) 1
				}
			}
			b {
				if { $found(a) } then {
               puts stderr "$argv0: Only one of -a and -b may be specified!"
               usage
				} else {
               set found(b) 1
				}
			}
			o {
				set found(o) $arg
			}
		}
	}
}

set argv [ lrange $argv $optind end ]

if { $found(a) } then {
	puts stdout "Found option -a"
}

if { $found(b) } then {
	puts stdout "Found option -b"
}

if { [ string length $found(o) ] } then {
	puts stdout "Found option -o:$found(o)"
}

puts -nonewline stdout "The rest of the arguments are: "
set prefix ""
foreach arg $argv {
	puts -nonewline stdout "$prefix $arg"
	set prefix ", "
	
}
puts stdout ""
