/*
 *
 *  mread.c - CR Space read access
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "mtcr.h"

void usage(const char *n)
{
    printf("%s <device> <addr> [<i2c_slave>]\n", n);
    exit(1);
}

int main(int ac, char *av[])
{
    char          *endp;
    int           rc=0;
    unsigned int  addr, val;
    mfile         *mf;
    DType         dtype = MST_TAVOR;

#if 0
    int  i, rc1;
    char buf[1024], *p=buf;
    rc1 = mdevices(buf, 1024);
    for (i=0; i<rc1; i++)
    {
        printf("Found: \"%s\"\n", p);
        p += strlen(p)+1;
    }
    exit(0);
#endif

    if (ac < 3)
        usage(av[0]);
    addr = strtoul(av[2], &endp, 0);
    if (*endp)
        usage(av[0]);

    if (strstr(av[1], "mt21108_pci") && !strstr(av[1], "i2cm"))
        dtype = MST_GAMLA;
    mf = mopend(av[1], dtype);
    if (!mf)
    {
        perror("mopen");
        return 1;
    }

    if (ac >= 4)
        mset_i2c_slave(mf, strtoul(av[3],0,0));

    if ((rc = mread4(mf, addr, &val)) < 0)
    {
        mclose(mf);
        perror("mread");
        return 1;
    }
    if (rc < 4)
    {
        mclose(mf);
        printf("Read only %d bytes\n", rc);
        return 1;
    }

    mclose(mf);
    printf("Read 0x%08x:0x%08x\n", addr, val);
    return rc;
}
