#ifndef H_MST_CALBR_H
#define H_MST_CALBR_H

#include <linux/ioctl.h>

/* These will be specific for calibr */
#define CALBR_MAGIC 0xD3

typedef enum {
  calbr_i2c_clk_rate_90k,
  calbr_i2c_clk_rate_45k,
  calbr_i2c_clk_rate_11k,
  calbr_i2c_clk_rate_1k5
} calbr_i2c_clk_rate_t;

#define CALBR_INIT _IOC(_IOC_NONE,CALBR_MAGIC,0,sizeof(struct mst_calbr_init_st))
struct mst_calbr_init_st {
	unsigned short base;
	unsigned char  own;
	unsigned int   clk_rate; /*Pass enum clk_rate_t as a value*/
};

#define CALBR_STOP _IOC(_IOC_NONE,CALBR_MAGIC,1,0)

#define CALBR_TRANS _IOWR(CALBR_MAGIC,3,struct mst_trans_st)
#define MAX_TRANS_SIZE 64
#define MAX_WR_TRANS_SIZE (MAX_TRANS_SIZE+4)
#define MAX_RD_TRANS_SIZE MAX_TRANS_SIZE
struct mst_trans_st {
  unsigned char slv_addr;
  unsigned char wr_buff[MAX_WR_TRANS_SIZE]; /*Actual supported size may be less,
                                              depending on the device */
  unsigned int wr_size;
  unsigned char rd_buff[MAX_RD_TRANS_SIZE];
  unsigned int rd_size;
  unsigned int wr_count; /*OUT*/
  unsigned int rd_count; /*OUT*/
};

#endif
