#ifndef H_MST_IRQ_H
#define H_MST_IRQ_H

#include <linux/ioctl.h>

/* These will be specific for PCI */
#define IRQ_MAGIC 0xE1

#define IRQ_INIT _IOC(_IOC_NONE,IRQ_MAGIC,0,sizeof(struct mst_irq_init_st))
struct mst_irq_init_st {
  unsigned int bus;
  unsigned int devfn;
  int bar;
  unsigned int gpio_val;
};

#define IRQ_STOP _IOC(_IOC_NONE,IRQ_MAGIC,1,0)

#define IRQ_PARAMS _IOR(IRQ_MAGIC,2,struct mst_irq_init_st)
struct mst_irq_params_st {
	unsigned long bar;
	unsigned long size;
};

#define IRQ_BLOCK _IOR(IRQ_MAGIC,3,unsigned int)

#endif
