/*
 *
 *  mstop.c - CR Space access stop
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "mst_pci.h"
#include "mst_pciconf.h"
#include "mst_calbr.h"
#ifdef MST_CPU_ppc_8xx
  #include "mst_ppc.h"
#endif

void usage(const char *n)
{
    
    printf("\n\t%s <device>\n",n);
    exit(1);
}

int main(int ac, char *av[])
{
    char          *devname;
    int           rc = 0, fd;

    if (ac < 2)
        usage(av[0]);

    devname = av[1];
    if (strstr(devname, "pciconf"))
    {
        /* PCICONF stop */
        if ((fd = open(devname, O_RDWR | O_SYNC)) < 0)
        {
            perror("open");
            return 1;
        }
        rc = ioctl(fd, PCICONF_STOP, NULL);
    }
    else if (strstr(devname, "pci"))
    {
        /* PCI stop */
        if ((fd = open(devname, O_RDWR | O_SYNC)) < 0)
        {
            perror("open");
            return 1;
        }
        rc = ioctl(fd, PCI_STOP, NULL);
    }
    else if (strstr(devname, "calbr") || strstr(devname, "calibre"))
    {
        /* Calibre stop */
        if ((fd = open(devname, O_RDWR | O_SYNC)) < 0)
        {
            perror("open");
            return 1;
        }
        rc = ioctl(fd, CALBR_STOP, NULL);
    }
#ifdef MST_CPU_ppc_8xx
	else if (strstr(devname, "ppc"))
	{
		/* PPC Stop */
        if ((fd = open(devname, O_RDWR | O_SYNC)) < 0)
        {
            perror("open");
            return 1;
		}
        rc = ioctl(fd, PPC_STOP, NULL);
	}
#endif
    else
    {
        printf("Invalid device name. Use that:\n");
        usage(av[0]);
    }
    return rc;
}
