/*
 *
 *  mtcr_ib_private.h - Mellanox Software tools (mst) IB related data definitions
 *
 */

#ifndef _MTCR_IB_PRIVATE_H
#define _MTCR_IB_PRIVATE_H

#include <asm/byteorder.h>
#include <endian.h>

#include <mtl_common.h>
#include <ib_mgt.h>

#define DEVICE_NAME     "InfiniHost0"
#define DEVICE_PORT     2
#define VENDOR_CLASS    0x09
#define VENDOR_GET      0x01
#define VENDOR_SET      0x02
#define SEND_TIMEOUT    100
#define FAST_CHECKS     100
#define SLOW_CHECKS     10
#define SLOW_PAUSE      1000 /* usecs */
#define RESEND_TRIES    10

typedef struct mad_payload_t {
#if __BYTE_ORDER == __LITTLE_ENDIAN
    /* -------------------------------*/
    u_int32_t method:7;         /* 0  */
    u_int32_t r:1;
    u_int32_t ClassVersion:8;
    u_int32_t MgmtClass:8;
    u_int32_t BaseVersion:8;
    /* -------------------------------*/
    u_int16_t ClassSpecific;    /* 4  */
    u_int16_t Status;
    /* -------------------------------*/
    u_int64_t TransactionID;    /* 8  */
    /* -------------------------------*/
    u_int16_t RESERVED1;        /* 16 */
    u_int16_t AttributeID;
    /* -------------------------------*/
    u_int32_t BurstAddress:16;  /* AttributeModifier 20 */
    u_int32_t Count:6;
    u_int32_t Mode:2;
    u_int32_t RESERVED2:8;
    /* -------------------------------*/
    u_int64_t VendorKey;        /* Data (24 - 28)  */
    u_int32_t Data[58];         /* Data (32 - 252) */

#elif __BYTE_ORDER == __BIG_ENDIAN

    /* -------------------------------*/
    u_int32_t BaseVersion:8;    /* 0  */
    u_int32_t MgmtClass:8;
    u_int32_t ClassVersion:8;
    u_int32_t r:1;
    u_int32_t method:7;
    /* -------------------------------*/
    u_int16_t Status;           /* 4  */
    u_int16_t ClassSpecific;
    /* -------------------------------*/
    u_int64_t TransactionID;    /* 8  */
    /* -------------------------------*/
    u_int16_t AttributeID;      /* 16 */
    u_int16_t RESERVED1;
    /* -------------------------------*/
    u_int32_t RESERVED2:8;      /* AttributeModifier 20 */
    u_int32_t Mode:2;
    u_int32_t Count:6;
    u_int32_t BurstAddress:16;
    /* -------------------------------*/
    u_int64_t VendorKey;        /* Data (24 - 28)  */
    u_int32_t Data[56];         /* Data (32 - 252) */

#else
#error "Wrong endianess"
#endif
} MAD_payload;

typedef struct mib_private_t {
    IB_MGT_mad_hndl_t hndl;
    IB_ud_av_t        udav;
    u_int64_t         trid;
} MIB_Private;

#endif
