/*
 *
 *  mread.c - CR Space read access
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "mtcr.h"

void usage(const char *n)
{
    printf("%s <device> <addr> <i2c_slave> <iter> <len>\n", n);
    exit(1);
}

int main(int ac, char *av[])
{
    char          *endp;
    int           rc=0;
    unsigned int  addr, val, iter, count;
    unsigned int  len, real_len;
    mfile         *mf = 0;
    DType         dtype = MST_GAMLA;
    int  i, rc1;
    char buf[1024], *p=buf;
    char ibuf[64];
    char obuf[64];

    if (ac != 6)
        usage(av[0]);
 
    rc1 = mdevices(buf, 1024, MDEVS_ALL);
    for (i=0; i<rc1; i++)
    {
        printf("Found: \"%s\"\n", p);
        p += strlen(p)+1;
    }

    addr = strtoul(av[2], &endp, 0);
    if (*endp)
        usage(av[0]);

    if (strstr(av[1], "mt21108_pci") && !strstr(av[1], "i2cm"))
	    dtype = MST_GAMLA;

    mf = mopend(av[1], dtype);
    if (!mf)
    {
        perror("mopen");
        return 1;
    }

    for(count = 0; count < 64; count++)
	    ibuf[count] = count;

    mf->i2c_slave = strtoul(av[3], &endp, 0);
    if (*endp)
	    usage(av[0]);

    iter = strtoul(av[4], &endp, 0);
    if (*endp)
	 usage(av[0]);
   
    len = strtoul(av[5], &endp, 0);
    if (*endp)
	 usage(av[0]);


   

    for(count = 0; count < iter; count++)
    {
	    switch(len)
	    {
		    case 0:
			    if(rand() & 1)
				    real_len = 4;
			    else 
				    real_len = 64;
			    break;
		    case 4:
			    real_len = 4;
			    break;
		    case 64: 
			    real_len = 64;
			    break;
		    default:
		            usage(av[0]);
			    return(-1);
	    }

	    if(real_len == 4)
		    rc = mread4(mf, addr, (u_int32_t*)obuf);
	    else 
		    rc = mread64(mf, addr, obuf, real_len);

	    if (rc < 0)
	    {
		    mclose(mf);
		    perror("mread");
		    return 1;
	    }

	    if (rc < real_len)
	    {
		    mclose(mf);
		    printf("Read only %d bytes\n", rc);
		    return 1;
	    }

    }

    mclose(mf);
    return rc;
}
