/*
 *
 *  mwrite.c - CR Space write access
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "mtcr.h"

void usage(const char *n)
{
    printf("%s <device> <addr> <value> [<i2c_slave>]\n", n);
    exit(1);
}

int main(int ac, char *av[])
{
    char          *endp;
    int           rc=0;
    unsigned int  addr, val;
    mfile         *mf;
    DType         dtype = MST_TAVOR;

    if (ac < 4)
        usage(av[0]);
    addr = strtoul(av[2], &endp, 0);
    if (*endp)
        usage(av[0]);
    val = strtoul(av[3], &endp, 0);
    if (*endp)
        usage(av[0]);

    if (strstr(av[1], "mt21108_pci") && !strstr(av[1], "i2cm"))
        dtype = MST_GAMLA;
    mf = mopend(av[1], dtype);
    if ( !mf )
    {
        perror("mopen");
        return 1;
    }

    if (ac >= 5)
        mset_i2c_slave(mf, strtoul(av[4],0,0));

    if ((rc = mwrite4(mf, addr, val)) < 0)
    {
        mclose(mf);
        perror("mwrite");
        return 1;
    }
    if (rc < 4)
    {
        mclose(mf);
        printf("Write only %d bytes\n", rc);
        return 1;
    }
    mclose(mf);
    return 0;
}
