#include <unistd.h>
#include <fcntl.h>
#include "usbioctl.h"

int main(int argc, char** argv)
{
  int cnt=0;
  int ret;
  int expected;
  I2C_TRANS rtrans={
    byTransType:I2C_TRANS_NOADR,
    bySlvDevAddr:0x48<<1, /* Gamla, fix for Tavor */
    /* wMemoryAddr:0, */
    wCount:4,
    Data:{0x14,00,0x0f,0x00},
  };
  I2C_TRANS wtrans={
    byTransType:I2C_TRANS_NOADR,
    bySlvDevAddr:0x48<<1, /* Gamla, fix for Tavor */
    /* wMemoryAddr:_be16(0x2800), */
    wCount:4,
    Data:{0x00,0x0f,0x00,0x14},
  };
  I2C_TRANS dtrans = {
	  wCount:64,
	  Data:{}
	  ,
  };

  int fd= open(argv[1], O_RDWR);
  if (fd<0) {
    perror();
    printf("fd=%d\n", fd);
    return -10;
  }
retry_first:
  ret=mst_WriteI2c(fd,&wtrans);
  if (ret<=0) goto retry_first;

  if (ret!=4){
    perror();
    printf("1. ret=%d\n", ret);
    goto error;
  }
  ret=mst_ReadI2c(fd,&rtrans);
  if (ret<=0) goto retry_first;
  if (ret!=4) {
    perror();
    printf("2. ret=%d\n", ret);
    goto error;
  }
  expected=*(int*)rtrans.Data;

  printf("0x%x%x%x%x\n",rtrans.Data[0],rtrans.Data[1],rtrans.Data[2],rtrans.Data[3]);

  /*  Now test */
  for(;;) {
retry:
	  ret=mst_WriteI2c(fd,&wtrans);
          if (ret<=0) goto retry;
	  if (ret!=4){
	    perror();
	    printf("3. ret=%d\n", ret);
            goto error;
	  }

	  ret=mst_ReadI2c(fd,&rtrans);
          if (ret<=0) goto retry;
	  if (ret!=4) {
	    perror();
	    printf("4. ret=%d\n", ret);
            goto error;
	  }

	  if (expected!=*(int*)rtrans.Data) {
	    printf("cnt=%d, expected=%x, actual=%x\n", cnt, expected, *(int*)rtrans.Data);
             goto error;
          }
           printf("%7d\b\b\b\b\b\b\b", cnt);
           cnt++;
  }
  return ret;

error:
    do {
	    ret=mst_Debug(fd,&dtrans);
	    dtrans.Data[ret]=0;
	    if (ret >0) printf("%64s",dtrans.Data);
    } while (ret == 64);
    printf("\n");
    printf("---------\n");

  return ret;
}
