#include <unistd.h>
#include <fcntl.h>
#include "usbioctl.h"

int main(int argc, char** argv)
{
  int cnt=0;
  int ret;
  int expected;
  I2C_TRANS rtrans={
    byTransType:I2C_TRANS_NOADR,
    bySlvDevAddr:0x48<<1, /* Gamla, fix for Tavor */
    /* wMemoryAddr:0, */
    wCount:4,
    Data:{0x00,00,0x00,0x00},
  };
  I2C_TRANS rwtrans={
    byTransType:I2C_TRANS_NOADR,
    bySlvDevAddr:0x48<<1, /* Gamla, fix for Tavor */
    /* wMemoryAddr:0, */
    wCount:8,
    Data:{0x00,0x08,0x20,0x00,0,0,0,0},
  };
  I2C_TRANS wtrans={
    byTransType:I2C_TRANS_NOADR,
    bySlvDevAddr:0x48<<1, /* Gamla, fix for Tavor */
    /* wMemoryAddr:_be16(0x2800), */
    wCount:4,
    Data:{0x00,0x08,0x20,0x00},
  };
  I2C_TRANS dtrans = {
	  wCount:64,
	  Data:{}
	  ,
  };

  int fd= open(argv[1], O_RDWR);
  if (fd<0) {
    perror();
    printf("fd=%d\n", fd);
    return -10;
  }
  *(int*)(rwtrans.Data+4)=expected;
retry_firstwrite:
  ret=mst_WriteI2c(fd,&rwtrans);
  if (ret<=0){ goto retry_firstwrite; }
  if (ret!=8){
    perror();
    printf("ret=%d\n", ret);
    goto error;
  }
retry_first:
  ret=mst_WriteI2c(fd,&wtrans);
  if (ret<=0){ goto retry_first; }
  if (ret!=4){
    perror();
    printf("ret=%d\n", ret);
    goto error;
  }
  ret=mst_ReadI2c(fd,&rtrans);
  if (ret<=0){ goto retry_first; }
  if (ret!=4) {
    perror();
    printf("ret=%d\n", ret);
    goto error;
  }
  expected=*(int*)rtrans.Data;

  printf("0x%x%x%x%x\n",rtrans.Data[0],rtrans.Data[1],rtrans.Data[2],rtrans.Data[3]);

  /*  Now test */
  for(;;) {
    retry_write:
          expected++;
          *(int*)(rwtrans.Data+4)=expected;
	  ret=mst_WriteI2c(fd,&rwtrans);
          if (ret<=0) { goto retry_write; }
	  if (ret!=8){
	    perror();
	    printf("ret=%d\n", ret);
              goto error;
	  }

retry:
          *(int*)rtrans.Data=-16;

	  ret=mst_WriteI2c(fd,&wtrans);
          if (ret<=0) { goto retry; }
	  if (ret!=4){
	    perror();
	    printf("ret=%d\n", ret);
              goto error;
	  }

	  ret=mst_ReadI2c(fd,&rtrans);
          if (ret<=0) { goto retry; }
	  if (ret!=4) {
	    perror();
	    printf("ret=%d\n", ret);
              goto error;
	  }

	  if (expected!=*(int*)rtrans.Data) {
	    printf("cnt=%d, expected=%x, actual=%x\n", cnt, expected, *(int*)rtrans.Data);
              ret=-7;
              goto error;
          }
           printf("%7d\b\b\b\b\b\b\b", cnt);
           cnt++;
  }

error:
    do {
	    ret=mst_Debug(fd,&dtrans);
	    dtrans.Data[ret]=0;
	    if (ret >0) printf("%64s",dtrans.Data);
    } while (ret == 64);
    printf("\n");

  return ret;
}
