/*
 *
 *  mtcr.h - Mellanox Software tools (mst) driver definitions
 *
 */

#ifndef _USBIOCTL_H
#define _USBIOCTL_H

typedef enum {
  /*  supported transaction types */
  I2C_TRANS_NOADR,          /*  read or write with no address cycle */
  I2C_TRANS_8ADR,           /*  read or write with 8 bit address cycle */
  I2C_TRANS_16ADR           /*  read or write with 16 bit address cycle */
} I2C_TRANS_TYPE;

typedef struct _I2C_TRANS {
  unsigned char byTransType;
  unsigned char bySlvDevAddr;
  unsigned int wMemoryAddr;
  int wCount;
  unsigned char Data[256];
} I2C_TRANS, *PI2C_TRANS;

int mst_WriteI2c(int fd, PI2C_TRANS tr);
int mst_ReadI2c(int fd, PI2C_TRANS tr);
int mst_ReadIoPorts(int fd, PI2C_TRANS tr);
int mst_WriteIoPorts(int fd, PI2C_TRANS tr);
int mst_Debug(int fd, PI2C_TRANS tr);


/*  Dimax */

int dimax_ReadI2c( int fd, PI2C_TRANS tr, int size );
int dimax_WriteI2c( int fd, PI2C_TRANS tr, int size );

#endif
