/*
 * Copyright (C) Voltaire Ltd. 2001-2003.  ALL RIGHTS RESERVED.
 *
 * This source code (the "Code") is a proprietary product of Voltaire Ltd.
 * (the "Company") and all right, title, and interest in and to the Code,
 * including all associated intellectual property rights, are and shall
 * remain exclusively with the Company.
 *
 * The Code is provided "as is". To the maximum extent permitted by law,
 * the Company disclaims any warranties of any kind, either expressed or
 * implied, including, without limitation, implied warranties of
 * merchantability, fitness for a particular purpose and non-infringement.
 * The Company does not warrant that the Code will operate error free, or
 * in an uninterrupted fashion or that it is compatible with any particular
 * platform. In no event shall the Company be liable for any damages
 * whatsoever (including, without limitation, incidental, direct, indirect,
 * special and consequential damages, damages for loss of business profits,
 * business interruption, loss of business information, or other pecuniary
 * loss) arising out of the use or inability to use the Code, even if
 * advised of the possibility of such damages.
 */

//cm-constants.h
// Suppress duplicate loading of this file
#ifndef _CM_CONSTANTS_H_
#define _CM_CONSTANTS_H_

					   

#define CM_MAD_SIZE						MAD_BLOCK_SIZE
#define CM_WELLKNOWN_QPN				1
#define CM_WELLKNOWN_QKEY				0x80010000
#define CM_MAX_CONNECTIONS				2000
#define CM_DGRM_SIZE					296	
#define CM_DGRM_POOL_SIZE				CM_MAX_CONNECTIONS * 2

// Default turnaround time setting
#define CM_TURNAROUND_TIME_MS			1000	// 1 s

// Default SIDR req timeout
#define SIDR_REQ_TIMEOUT_MS				400		// 400 ms

#define MAX_REP_RETRIES					3
#define MAX_REQ_RETRIES                 3
#define MAX_DREQ_RETRIES                3


// states possible for a CEP object				
typedef enum {
	CMS_IDLE=1,		    // 1
	CMS_LISTEN,		    // 2
	CMS_REQ_SENT,		// 3
	CMS_REQ_RCVD,		// 4
	CMS_REP_SENT,		// 5
	CMS_REP_RCVD,		// 6
	CMS_REP_TIMEOUT,	// 7
	CMS_RTU_TIMEOUT,	// 8
	CMS_ESTABLISHED,	// 9
	CMS_DREQ_SENT,		// 10
	CMS_DREQ_RCVD,		// 11
	CMS_TIMEWAIT,		// 12
	CMS_REGISTERED,		// 13
	CMS_SIDR_REQ_SENT,	// 14
	CMS_SIDR_REQ_RCVD,	// 15
	CMS_SIDR_RESP_SENT,	// 16
	CMS_SIDR_RESP_RCVD,	// 17
	CMS_DESTROY         // 18
} cm_cep_state_t;


#endif //_CM_CONSTANTS_H_
