
/*
 * Copyright (C) Voltaire Ltd. 2001-2003.  ALL RIGHTS RESERVED.
 *
 * This source code (the "Code") is a proprietary product of Voltaire Ltd.
 * (the "Company") and all right, title, and interest in and to the Code,
 * including all associated intellectual property rights, are and shall
 * remain exclusively with the Company.
 *
 * The Code is provided "as is". To the maximum extent permitted by law,
 * the Company disclaims any warranties of any kind, either expressed or
 * implied, including, without limitation, implied warranties of
 * merchantability, fitness for a particular purpose and non-infringement.
 * The Company does not warrant that the Code will operate error free, or
 * in an uninterrupted fashion or that it is compatible with any particular
 * platform. In no event shall the Company be liable for any damages
 * whatsoever (including, without limitation, incidental, direct, indirect,
 * special and consequential damages, damages for loss of business profits,
 * business interruption, loss of business information, or other pecuniary
 * loss) arising out of the use or inability to use the Code, even if
 * advised of the possibility of such damages.
 */

/* 
 * Mellanox IB_MGT compatibility layer. Used by OpenSM
 */

#ifndef _IB_MGT_COMPAT_H
#define _IB_MGT_COMPAT_H

IB_MGT_ret_t
vltr_IB_MGT_get_handle(const char *dev_name, IB_port_t port_num,
		IB_MGT_mad_type_t mad_type, IB_MGT_mad_hndl_t *mad_hndl_p);

IB_MGT_ret_t
vltr_IB_MGT_release_handle(IB_MGT_mad_hndl_t mad_hndl);

IB_MGT_ret_t
vltr_IB_MGT_bind_gsi_class(IB_MGT_mad_hndl_t mad_hndl, u_int8_t mgt_class);

IB_MGT_ret_t
vltr_IB_MGT_unbind_gsi_class(IB_MGT_mad_hndl_t mad_hndl, u_int8_t mgt_class);

IB_MGT_ret_t
vltr_IB_MGT_bind_sm(IB_MGT_mad_hndl_t mad_hndl);

IB_MGT_ret_t
vltr_IB_MGT_unbind_sm(IB_MGT_mad_hndl_t mad_hndl);

IB_MGT_ret_t
vltr_IB_MGT_reg_cb(IB_MGT_mad_hndl_t mad_hndl, IB_MGT_mad_rcv_cb_t rcv_notify_cb,
		void *rcv_private_ctx_p, IB_MGT_mad_send_cb_t send_notify_cb,
		void *send_private_ctx_p, u_int32_t cb_mask);

IB_MGT_ret_t
vltr_IB_MGT_send_mad(IB_MGT_mad_hndl_t mad_hndl, void *MAD_payload_p,
		const IB_ud_av_t *udav_p, u_int64_t wrid, u_int32_t timeout);

IB_MGT_ret_t
vltr_IB_MGT_send_mad_to_qp(IB_MGT_mad_hndl_t mad_hndl, void * MAD_payload_p,
		const IB_ud_av_t *udav_p, u_int64_t wrid,
		u_int32_t timeout, VAPI_qp_num_t remote_qp);

#ifndef _VLTR_NO_FUNC_REDEFINE
#define IB_MGT_get_handle vltr_IB_MGT_get_handle
#define IB_MGT_release_handle vltr_IB_MGT_release_handle
#define IB_MGT_bind_gsi_class vltr_IB_MGT_bind_gsi_class
#define IB_MGT_unbind_gsi_class vltr_IB_MGT_unbind_gsi_class
#define IB_MGT_bind_sm vltr_IB_MGT_bind_sm
#define IB_MGT_unbind_sm vltr_IB_MGT_unbind_sm
#define IB_MGT_reg_cb vltr_IB_MGT_reg_cb
#define IB_MGT_send_mad vltr_IB_MGT_send_mad
#define IB_MGT_send_mad_to_qp vltr_IB_MGT_send_mad_to_qp
#endif




#endif
