#ifndef __VV_THREAD_TIMER_H__
#define __VV_THREAD_TIMER_H__

#include <linux/timer.h>



void init_timing(struct timer_list * timer);
void add_timing(struct timer_list *timer);
int del_timing(struct timer_list *timer);
int del_timing_sync(struct timer_list *timer);
int mod_timing(struct timer_list *timer, unsigned long expires);
int timing_pending(struct timer_list * timer);
void sync_timings(void);
int get_timer_wakeups(void);


#ifdef VV_THREAD_TIMERS
#define INIT_TIMER(x)     init_timing(x)
#define ADD_TIMER(x)      add_timing(x)
#define DEL_TIMER(x)      del_timing(x)
#define DEL_TIMER_SYNC(x) del_timing_sync(x)
#define MOD_TIMER(x, y)   mod_timing(x, y)
#define TIMER_PENDING(x)  timing_pending(x)
#else 
#define INIT_TIMER(x)     init_timer(x)
#define ADD_TIMER(x)      add_timer(x)
#define DEL_TIMER(x)      del_timer(x)
#define DEL_TIMER_SYNC(x) del_timer_sync(x)
#define MOD_TIMER(x, y)   mod_timer(x, y)
#define TIMER_PENDING(x)  timer_pending(x)
#endif


#endif /* #ifdef__VV_THREAD_TIMER_H__ */
