#!/bin/bash

if [ -z $1 ] ; then
	echo "Usage: $0 PortXmitData|PortRcvData|PortXmitPkts|PortRcvPkts"
	exit 1
fi
COUNTER=$1

# Work out what multicast channel we are on (rather assumes there is only one space).
MCAST=`grep 'mcast_join =' /etc/gmond.conf  | grep -v \* | head -n 1 | awk  '{printf $3}' | sed 's/"//g'`
PORT=`grep 'port =' /etc/gmond.conf  | grep -v \* | head -n 1 | awk  '{printf $3}' | sed 's/"//'`
TTL=`grep '^mcast_ttl' /etc/gmond.conf | awk '{printf $2}'`
INTERFACE=`grep '^mcast_if' /etc/gmond.conf | awk '{printf $2}'`

[ -z "$MCAST" ] && MCAST="239.2.11.71"
[ -z "$PORT" ]  && PORT=8649
[ -z "$TTL" ] && TTL=1
[ -z "$INTERFACE" ] && INTERFACE="ipoib0"

if [ -e /usr/mellanox/bin/vstat ] ; then
	if ( /usr/mellanox/bin/vstat > /dev/null 2>&1 ) ; then
		PORT1=`/usr/mellanox/bin/vstat | grep -A 1 port=1 | grep port_state | awk -F "=" ' {print $2}'`
		PORT2=`/usr/mellanox/bin/vstat | grep -A 1 port=2 | grep port_state | awk -F "=" ' {print $2}'`
		# Get Counters
		if [[ $PORT1 = "PORT_ACTIVE" ]] ; then
			case "$COUNTER" in
			PortXmitData)
				typeset -i DATA=`/usr/mellanox/bin/get_pcounter -p 1 | grep PortXmitData | awk ' { print $2 }'`
				/usr/mellanox/bin/get_pcounter -p 1 -s 1  > /dev/null 2>&1
				TYPE="MB" 
			;;
			PortRcvData)
				typeset -i DATA=`/usr/mellanox/bin/get_pcounter -p 1 | grep PortRcvData | awk ' { print $2 }'`
				/usr/mellanox/bin/get_pcounter -p 1 -s 2 > /dev/null 2>&1
				TYPE="MB" 
			;;
			PortXmitPkts)
				typeset -i DATA=`/usr/mellanox/bin/get_pcounter -p 1 | grep PortXmitPkts | awk ' { print $2 }'`
				/usr/mellanox/bin/get_pcounter -p 1 -s 3 > /dev/null 2>&1
				TYPE="Packet" 
			;;
			PortRcvPkts)
				typeset -i DATA=`/usr/mellanox/bin/get_pcounter -p 1 | grep PortRcvPkts | awk ' { print $2 }'`
				/usr/mellanox/bin/get_pcounter -p 1 -s 4 > /dev/null 2>&1
				TYPE="Packet" 
			;;
			esac
			if [[ "$TYPE" == "Packet" ]] ; then
				typeset -i OUTPUT=($DATA)/10
			else
				typeset -i OUTPUT=($DATA)/10*4/1024/1024
			fi
			gmetric -n$COUNTER -v$OUTPUT -tint8 -u"$TYPE/Sec" -x10 -spositive
			#echo "$OUTPUT"
		fi
		if [[ $PORT2 = "PORT_ACTIVE" ]] ; then
			case "$COUNTER" in
			PortXmitData)
				typeset -i DATA=`/usr/mellanox/bin/get_pcounter -p 2 | grep PortXmitData | awk ' { print $2 }'`
				/usr/mellanox/bin/get_pcounter -p 2 -s 1 > /dev/null 2>&1  
				TYPE="MB" 
			;;
			PortRcvData)
				typeset -i DATA=`/usr/mellanox/bin/get_pcounter -p 2 | grep PortRcvData | awk ' { print $2 }'`
				/usr/mellanox/bin/get_pcounter -p 2 -s 2 > /dev/null 2>&1  
				TYPE="MB" 
			;;
			PortXmitPkts)
				typeset -i DATA=`/usr/mellanox/bin/get_pcounter -p 2 | grep PortXmitPkts | awk ' { print $2 }'`
				/usr/mellanox/bin/get_pcounter -p 2 -s 3 > /dev/null 2>&1  
				TYPE="Packet" 
			;;
			PortRcvPkts)
				typeset -i DATA=`/usr/mellanox/bin/get_pcounter -p 2 | grep PortRcvPkts | awk ' { print $2 }'`
				/usr/mellanox/bin/get_pcounter -p 2 -s 4 > /dev/null 2>&1  
				TYPE="Packet" 
			;;
			esac
			if [[ "$TYPE" == "Packet" ]] ; then
				typeset -i OUTPUT=($DATA)/10
			else
				typeset -i OUTPUT=($DATA)/10*4/1024/1024
			fi
			gmetric -n$COUNTER -v$OUTPUT -tint32  -u"$TYPE/Sec" -x10 -spositive
			#echo "$OUTPUT"
		fi
	fi
fi	

