#!/bin/bash
#
# Main script
#
# Created 19/11/2003


start-suse()
{
	echo -n "SSH Connections "
	./ssh.sh $FILENAME
	rc_status -v
	sleep 2
	rc_reset

	echo -n "RSH Connections "
	./rsh.sh $FILENAME
	rc_status -v
	sleep 2
	rc_reset

	echo -n "VAPI Interface "
	./get-host-lid-ip.sh $FILENAME
	rc_status -v
	sleep 2
	rc_reset

	echo -n "IPoIB Interface "
	./ping.sh
	rc_status -v
	sleep 2
	rc_reset

	echo -n "MPI Bandwidth "
	./mpi.sh
	rc_status -v
	sleep 2
	rc_reset

	echo -n "MPI Scaling "
	./mpi.scale.sh
	rc_status -v
	sleep 2
	rc_reset

	echo -n "MPI Stressing "
	./mpi.stress.sh
	rc_status -v
	sleep 2
}

start-rh()
{

	action $"SSH Connections" ./ssh.sh $FILENAME
	action $"RSH Connections" ./rsh.sh $FILENAME
	action $"VAPI Interface" ./get-host-lid-ip.sh $FILENAME
	action $"IPoIB Interface" ./ping.sh
	action $"MPI Bandwidth" ./mpi.sh
	action $"MPI Scaling" ./mpi.scale.sh
	action $"MPI Stressing" ./mpi.stress.sh
}


FILENAME=$1

if [ -z $FILENAME ] ; then
	echo "Missing hostfile !"
	echo "Usage all.sh filename"
	exit 1
fi

. /etc/init.d/functions
. /etc/rc.status

clear
echo "Voltaire HCA400 Host Stack Check:"

if [ -f /etc/SuSE-release ] || [ -f /etc/UnitedLinux-release ] ; then
        SLEEPTIME=1
	start-suse
elif [ -f /etc/redhat-release ] ; then
	SLEEPTIME=0.1
	start-rh
else
	echo "Not Supported !!"
        SLEEPTIME=1
fi

