#!/bin/bash
#
# This script get the VAPI status from all the nodes in the supplied file.
# for each active node the lid and IPOIB ip-address is taken into the file host-lid-ip.txt.
# The created file is then beening cut to 3 file:
# 1. The current active host ( Hosts that have an active port
# 2. The active port lid
# 3. The active port IPoIB ip address
#
# Created 19/11/2003

set -e
. command
#Clean last runs
rm -rf active-hosts.txt active-lids.txt active-ipoib.txt host-lid-ip.txt hosts.err
# SET HERE THE NAME OF THE CLUSTER NODES FILE 
NODES_FILE=$1

if [ -z $NODES_FILE ] ; then
        echo "Missing hostfile !"
        echo "Usage get-host-lid-ip.sh filename"
        exit 1
fi

if [ -f /etc/SuSE-release ] || [ -f /etc/UnitedLinux-release ] ; then
	SLEEPTIME=1
elif [ -f /etc/redhat-release ] ; then
       SLEEPTIME=0.1
else
        SLEEPTIME=1
fi

NUM_OF_HOSTS=`cat ${NODES_FILE} | wc -l `

for node in `cat ${NODES_FILE}` ;
  do
    if( $COMMAND ${node} ". /etc/profile; vapi status" | grep -q PORT_ACTIVE )
    then 
        port_stat=`$COMMAND ${node} ". /etc/profile; vapi status" | grep port_lid | head -1 | sed s/port_lid=//`	       
        ip_address=`$COMMAND ${node} ". /etc/profile; /sbin/ifconfig ipoib0" | grep 'inet addr:'  | awk '{ print $2 }' | sed s/addr://`	       
        echo "$node ${port_stat} ${ip_address}"  >> host-lid-ip.txt
    else
	echo "$node ${port_stat} ${ip_address} " >> hosts.err	 
    fi
    sleep $SLEEPTIME 
    (( n++ ))
  done

cat host-lid-ip.txt | awk ' { print $1 } ' > active-hosts.txt
cat host-lid-ip.txt | awk ' { print $2 } ' > active-lids.txt
cat host-lid-ip.txt | awk ' { print $3 } ' > active-ipoib.txt
NUM_OF_ACTIVE_HOSTS=`cat active-hosts.txt | wc -l `

if [[ $NUM_OF_HOSTS = $NUM_OF_ACTIVE_HOSTS ]] ; then
	echo "All hosts are active"
	exit 0
else
	echo "Some hosts are not active, see hosts.err"
	exit 1
fi

