#!/bin/bash
#
# This script uses the mpi_bandwidth utility to check the bandwidth (RC) between each pair
# The bandwidth should be at least 700MB for PCIX 133
#
# Created 19/11/2003
 
set -e
# Clear logs
rm -rf mpi.nn.err mpi.nn.txt

# SET HERE THE NAME OF THE CLUSTER NODES FILE 
NODES_FILE=active-hosts.txt

if [ $1 ] ; then
        NODES_FILE=$1
fi

if [ -f /etc/SuSE-release ] || [ -f /etc/UnitedLinux-release ] ; then
        SLEEPTIME=1
elif [ -f /etc/redhat-release ] ; then
       SLEEPTIME=0.1
else
        SLEEPTIME=1
fi


MIN_PERFORMACE=700
FLAG=0
for node in `cat ${NODES_FILE}` ;
  do
  for node1 in `cat ${NODES_FILE}` ;
	do
		if [[ "$node" != "$node1" ]] ; then
			RESULT=`. /etc/profile ; mpirun_rsh -np 2 ${node} ${node1} /usr/voltaire/mpi/bin/mpi_bandwidth 100 128000`
			RESULT=${RESULT:7}
			echo "${node} ${node1} => ${RESULT}" >> mpi.nn.txt 
			TMPRESULT=${RESULT:0:3}
		
			if (( $TMPRESULT < $MIN_PERFORMACE )) ; then
		        	echo "MPI bandwidth is to low between ${node} to ${REMOTE}" >> mpi.nn.err
				FLAG=1
			fi
		fi
		sleep $SLEEPTIME 
  	done
 done

if (( $FLAG == 0 )) ; then
	echo "All MPI bandwidth is OK"
        exit 0
else
        echo "The MPI bandwidth on some nodes is not goot, see mpi.nn.err"
        exit 1
fi
