#!/bin/bash
#
# This script is using the mpi_bandwidth utility to check the bandwidth (RC) between nodes,
# the script runs in a circle A -> B -> C -> A.
# The bandwidth should be at least 700MB for PCIX 133
#
# Created 19/11/2003

set -e
. ./command

# Clear logs
rm -rf mpi.err mpi.txt

# SET HERE THE NAME OF THE CLUSTER NODES FILE 
NODES_FILE=active-hosts.txt
if [ $1 ] ; then
        NODES_FILE=$1
fi

if [ -f /etc/SuSE-release ] || [ -f /etc/UnitedLinux-release ] ; then
        SLEEPTIME=1
elif [ -f /etc/redhat-release ] ; then
       SLEEPTIME=0.1
else
        SLEEPTIME=1
fi


NUM_OF_HOSTS=`cat ${NODES_FILE} | wc -l `
MIN_PERFORMACE=700
m=2
FLAG=0
for node in `cat ${NODES_FILE}` ;
  do
	REMOTE=`cat active-hosts.txt| grep -m ${m} -G [a-zA-z0-9] | tail -1 `
	if (( $m <= $NUM_OF_HOSTS )) ; then
	RESULT=`. /etc/profile ; ${MPICOMMAND} -np 2 ${node} ${REMOTE} /usr/voltaire/mpi/bin/mpi_bandwidth 100 128000`
	RESULT=${RESULT:7}
	echo "${node} ${REMOTE} => ${RESULT}" >> mpi.txt
	#echo "${node} ${REMOTE} => ${RESULT}" >> mpi.txt
	TMPRESULT=${RESULT:0:3}
	fi
	if (( $TMPRESULT < $MIN_PERFORMACE )) ; then
        	echo "MPI bandwidth is to low between ${node} to ${REMOTE}" >> mpi.err
		FLAG=1
	fi

	sleep $SLEEPTIME
	(( m++ ))
  done

# Check last server
node=`tail -1 active-hosts.txt` 
REMOTE=`head -1 active-hosts.txt` 
RESULT=`. /etc/profile ; ${MPICOMMAND} -np 2 ${node} ${REMOTE} /usr/voltaire/mpi/bin/mpi_bandwidth 100 128000`
RESULT=${RESULT:7}
echo "${node} ${REMOTE} => ${RESULT}" >> mpi.txt
TMPRESULT=${RESULT:0:3}
if (( $TMPRESULT < $MIN_PERFORMACE )) ; then
      echo "MPI bandwidth is to low between ${node} to ${REMOTE}" >> mpi.err
      FLAG=1
fi

if (( $FLAG == 0 )) ; then
	echo "All MPI bandwidth is OK"
        exit 0
else
        echo "The MPI bandwidth on some nodes is not goot, see mpi.err"
        exit 1
fi
