#!/bin/bash
#
# This script uses the cluster-stress utility to stress up the fabric by doing concurrent 
# communication in one of three patterns: sendrecv (default), exchange or alltoall

# It can be run also manually over a hosts file containg nodes connected to one switch
# to get intra-switch stressing before going to inter-switch stressing.

# the success criterion is not well defined - so it always succeeds

# the number of processes used is one per cpu

# Created 24/11/2003

set -e
. command

# Clear logs
rm -rf mpi.stress.err mpi.stress.txt

# SET HERE THE NAME OF THE CLUSTER NODES FILE 
NODES_FILE=active-hosts.txt
if [ $1 ] ; then
        NODES_FILE=$1
fi
NUM_OF_HOSTS=`cat ${NODES_FILE} | wc -l `
m=2
FLAG=0

HOST=`cat ${NODES_FILE} | head -1`
CPU_NUMBER=`$COMMAND $HOST 'cat /proc/cpuinfo | grep processor | wc -l | sed s/"      "//'`

for (( i = 0 ; $i <= $CPU_NUMBER ; i = $i + 1 )) ; do
	rm -rf active-hosts.$i.txt
	for (( j = 0 ; $j <= $i ; j = $j + 1 )) ; do
		if (( $i != $j )) ; then
			cat active-hosts.txt >> active-hosts.$i.txt
		fi
	done	
done

(( i = $i - 1 ))
	(( NP = $NUM_OF_HOSTS * i ))
	RESULT=`${MPICOMMAND} -np $NP -hostfile active-hosts.$i.txt /usr/voltaire/mpi/bin/cstress 2>&1 | grep SUCCESS |  cut -d '-' -f 2`
	if [[ "XX${RESULT}XX" != "XX SUCCESS XX" ]] ; then
		for np in 90 80 70 60 50 40 30 20 ; do
			(( NP = $NP * $np / 100 ))
			if (( $NP > 0 )) ; then
				RESULT=`${MPICOMMAND} -np $NP -hostfile active-hosts.$i.txt /usr/voltaire/mpi/bin/cstress 2>&1 | grep SUCCESS |  cut -d '-' -f 2`
				if [[ "XX${RESULT}XX" == "XX SUCCESS XX" ]] ; then
					FLAG=$NP
					break
				fi
			fi
		done
	fi

if (( $FLAG == 0 )) ; then
	echo "MPI Stress Success (Up to $NP)"
        exit 0
else
        echo "Failed to Stress above $FLAG"
        exit 1
fi
