#!/bin/bash
#
# This script takes the active hosts ( this file is created by the get-host-lid-ip.sh script )
# and ping the ipoib interface in a circle A -> B -> C -> A
#
# Created 19/11/2003
  
set -e
. command
# Clear logs
rm -rf ping.err

# SET HERE THE NAME OF THE CLUSTER NODES FILE 
NODES_FILE=active-hosts.txt
if [ $1 ] ; then
        NODES_FILE=$1
fi

if [ -f /etc/SuSE-release ] || [ -f /etc/UnitedLinux-release ] ; then
        SLEEPTIME=1
	X=4
elif [ -f /etc/redhat-release ] ; then
       SLEEPTIME=0.1
	X=3
else
        SLEEPTIME=1
	X=4
fi

NUM_OF_HOSTS=`cat ${NODES_FILE} | wc -l `
TMP=`cat active-ipoib.txt | grep -m 1 -G [0-9]` 
IP_SIZE=${#TMP}
m=2
FLAG=0

for node in `cat ${NODES_FILE}` ;
  do
	REMOTE_IP=`cat active-ipoib.txt | grep -m ${m} -G [0-9] | tail -1 `
	RESULT=`$COMMAND ${node} "ping ${REMOTE_IP} -c 2 -w 10 | grep loss | cut -d ',' -f ${X} | sed s/'% loss'//"`
	LEN=${#RESULT}
	if (( $LEN < 4 )) ; then
	   if [[ -z $RESULT ]] ; then 
              RESULT=-1
	   fi
		if (( $RESULT > 0 )) ; then
        		echo "Cannot ping from ${node} to ${REMOTE_IP}" >> ping.err
			FLAG=1
		fi
	fi

	sleep $SLEEPTIME 
	(( m++ ))
  done

# Check last server

node=`tail -1 active-hosts.txt`
REMOTE_IP=`head -1 active-ipoib.txt`
RESULT=`$COMMAND ${node} "ping ${REMOTE_IP} -c 2 -w 10 | grep loss | cut -d ',' -f ${X} | sed s/'% loss'//"`
LEN=${#RESULT}

if (( $LEN < 4 )) ; then
   if [[ -z $RESULT ]] ; then 
      RESULT=-1
   fi
        if (( $RESULT > 0 )) ; then
                echo "Cannot ping from ${node} to ${REMOTE_IP}" >> ping.err
                FLAG=1
        fi
fi

if  (( $FLAG == 0 ))  ; then
	echo "All IPoIB interfaces are active"
        exit 0
else
        echo "Some IPoIB interfaces are not active, see ping.err"
        exit 1
fi
