#!/bin/bash
#
# Checks if RSH is enabled (Without entering password
#
# Created 19/11/2003

set -e

# SET HERE THE NAME OF THE CLUSTER NODES FILE 
NODES_FILE=$1

if [ -z $NODES_FILE ] ; then
        echo "Missing hostfile !"
        echo "Usage ./rsh.sh filename"
        exit 1
fi

NUM_OF_HOSTS=`cat ${NODES_FILE} | wc -l `
FLAG=0

for node in `cat ${NODES_FILE}` ; do
    if ( ! rsh ${node} "hostname"  >/dev/null 2>&1 ); then
	FLAG=1
	break
    fi
done

if (( $FLAG == 0 )) ; then
        echo "RSH is enabled"
	echo "COMMAND=rsh" > command
	echo "MPICOMMAND=mpirun_rsh" >> command
        exit 0
else
        echo "RSH is disabled"
        exit 1
fi

