#!/bin/bash
#
# Checks if SSH is enabled (Without entering password
#
# Created 19/11/2003


set -e

# SET HERE THE NAME OF THE CLUSTER NODES FILE 
NODES_FILE=$1

if [ -z $NODES_FILE ] ; then
        echo "Missing hostfile !"
        echo "Usage ./ssh.sh filename"
        exit 1
fi

NUM_OF_HOSTS=`cat ${NODES_FILE} | wc -l `
FLAG=0

for node in `cat ${NODES_FILE}` ; do
    if ( ! ssh ${node} "hostname"  >/dev/null 2>&1 ); then
	FLAG=1
	break
    fi	
done

if (( $FLAG == 0 )) ; then
        echo "SSH is enabled"
	echo "COMMAND=ssh" > command
	echo "MPICOMMAND=mpirun_ssh" >> command
        exit 0
else
        echo "SSH is disabled"
        exit 1
fi

