#!/bin/bash
# IBhost Post Installation
#
VOLTAIREUSR=/usr/voltaire
VOLTAIREVAR=/var/voltaire
MELLANOXDIR=/usr/mellanox
usage()
{
	echo
	echo "Usage: $0 [A]"
	echo "or  $0 [B]"
	echo
	echo "example: $0 A"
	echo "A - for setup IBhost-A"
	echo "B - for setup IBhost-B"
	echo
	echo
	return 1;
}
moving()
{
if test -f /etc/ld.so.preload ; then
	grep voltaire /etc/ld.so.preload >> /etc/ld.so.preload.voltaire ;
	if test -f /tmp/ld.so.preload.tmp ; then
		rm /tmp/ld.so.preload.tmp ;
	else
		grep -v voltaire /etc/ld.so.preload > /tmp/ld.so.preload.tmp ;
		mv /tmp/ld.so.preload.tmp  /etc/ld.so.preload ;
	fi;
fi;
if  test -L ${VOLTAIREUSR} || test -L ${VOLTAIREVAR} || test -L ${MELLANOXDIR}  ; then
	echo "one of the links ${VOLTAIREUSR},${VOLTAIREVAR},${MELLANOXDIR} already exists";
	echo "Check and correct links manually... exit";
	exit 1;
else
	if test -d ${MELLANOXDIR} ; then
		echo "Check for directory ${MELLANOXDIR} is OK" ;	
	else
		echo "directory ${VOLTAIREVAR} does not exist";
		echo "Check Installation status of IBhost software, exit..."
		exit 1;
	fi;
	if test -d ${VOLTAIREUSR} ; then
		echo "Check for directory ${VOLTAIREUSR} is OK" ;	
	else
		echo "directory ${VOLTAIREUSR} does not exist";
		echo "Check Installation status of IBhost software, exit..."
		exit 1;
	fi;
	if test -d ${VOLTAIREVAR} ; then
		echo "Check for directory ${VOLTAIREVAR} is OK" ;
	else
		echo "directory ${VOLTAIREVAR} does not exist";
		echo "creating empty ${VOLTAIREVAR}";
		mkdir ${VOLTAIREVAR};
	fi;

	echo "Renaming directories:";
	echo "${VOLTAIREVAR} to ${VOLTAIREVAR}-${IBSET}";
	(cd /; mv ${VOLTAIREVAR} ${VOLTAIREVAR}-${IBSET});
	echo "${MELLANOXDIR} to ${MELLANOXDIR}-${IBSET}";
	(cd /; mv ${MELLANOXDIR} ${MELLANOXDIR}-${IBSET});
	echo "${VOLTAIREUSR} to ${VOLTAIREUSR}-${IBSET}";
	(cd /; mv ${VOLTAIREUSR} ${VOLTAIREUSR}-${IBSET});
	echo "Renaming has been finished";
	exit 0;
fi;
}
case "$#" in
1)
	IBSET="$1"
	moving
	;;
*)
	usage
	;;
esac

