#!/bin/bash
#       /usr/voltaire/scripts/ibhost.all.init startup/shutdown script.
#
# Starts/Stops Voltaires IB host's services.
#
# chkconfig: 2345 08 92
# description: Voltaire InfiniBand Stack.
#

if [ "A${1}" == "Ahpc" ] ; then
    echo "Voltaire HPC Pack stop script....."
else
    echo "Voltaire ALL/BIZ pack stop script....."
fi


MODDIRS=/usr/voltaire/modules/$(uname -r)
export PATH="/usr/voltaire/bin:/usr/voltaire/scripts:/usr/mellanox/bin:$PATH"

# Functions
remove_module(){
    m=$1
    shift
    if  ! (lsmod |grep $m) ; then
    	return 0
    fi

    echo "removing $m"
    if ! rmmod $m  >/dev/null 2>&1 ; then
        exec  > /dev/tty
	echo "failed to remove module: $m"
	echo "Ibhost stop: failed to stop the stack"
        exit 1
   fi
   return 0
}

. /etc/profile
cd /usr/voltaire


# Stack stop script    
killall minism > /dev/null 2>&1
killall ibhost.$IBPKG.start.sh > /dev/null 2>&1
    

# Suspend any activity for the ibat - prevent race condition with arp CB.
echo halt > /proc/voltaire/ib-arp-table/control

IBLAN_ENABLED=$(rep-get modules/iblan enabled | perl -ne 'print hex')
IPOIB_UD_ENABLED=$(rep-get modules/ipoib-ud enabled | perl -ne 'print hex')

if [ ${IPOIB_UD_ENABLED} -eq 1 ]; then
	IPIB="ipoib"
fi
if [ ${IBLAN_ENABLED} -eq 1 ]; then
	IPIB="iblan"
fi

#ifconfig ${IPIB}0 down
for ((i=0;i<64;i++))
do	
        pkey=$(rep-get interfaces/ipoib-ud pkey$i | perl -ne 'print hex')
	if [[ $pkey -ne 0 ]]; then
		ifdown ipoib$i
		echo "del ipoib$i" > /proc/voltaire/ipoib-ud/control
	fi
done


# more robust test for voltaire stack
#if  ! (lsmod |grep -e "ad-tavor" -e "ad_tavor")
if  ! (lsmod | grep "hadump")
then
	if  (lsmod | grep "mosal")
	then
		vapi stop
		exec  > /dev/tty
	        echo ""
        	echo "Voltaire ibhost stack is not loaded - mlx modules where removed"
	        exit
	fi

	exec  > /dev/tty
	echo ""
	echo "Voltaire ibhost stack is not loaded"
	exit
fi

rm /dev/kdapltest > /dev/null 2>&1

remove_module kdapltest_module
remove_module kdapl
remove_module kdat_registry
remove_module sockets
remove_module sockets-aio
remove_module sdp
remove_module iblan
remove_module ipoib-ud
remove_module ipoib_ud
remove_module ats
remove_module devucm
remove_module cm
remove_module ibat
remove_module devugsi
remove_module gsim
remove_module q-mng
remove_module q_mng
remove_module vmr
remove_module ad-tavor
remove_module ad_tavor
remove_module vverbs
remove_module hadump
remove_module mlog
remove_module repository 
remove_module hadump
vapi stop
exit 0
