#!/bin/sh

MODE=global
if [ MODE = "local" ] ; then
	MOD_ROOT=.
else
	MOD_ROOT=/usr/voltaire/modules/`uname -r`
fi

# Functions

loadmodule(){
    m=$1
    if [ `uname -r | cut -f 1,2 -d .` = "2.6" ]; then
        m=`echo "$1" | sed s/\.o$/\.ko/g`
    fi
    shift
    # echo "loading $m"
    for d in ${MOD_ROOT} ; do
        if [ -e $d/$m ] ; then
            if ! insmod $d/$m "${@}" >/dev/null 2>&1 ; then
                echo "failed to load $m  !"
                return 1
	    else
		echo "loading $m  "
            fi
            return 0
        fi
    done
    echo "module '$m' not found."
    return 1
}

if [ MODE = "local" ] ; then
	loadmodule dat/kdat/kdat_registry.o DbgLvl=0x3
	loadmodule dapl/kdapl/kdapl.o       DbgLvl=0x10003
	loadmodule test/dapltest/kdapl/kdapltest_module.o
else
	loadmodule kdat_registry.o DbgLvl=0x3
	loadmodule kdapl.o       DbgLvl=0x10003
	loadmodule kdapltest_module.o
fi

if [ -e /dev/kdapltest ]; then
	rm /dev/kdapltest
fi
kdapltest_major=`grep kdapltest /proc/devices | cut -d' ' -f1`
kdapltest_minor=0
mknod /dev/kdapltest c $kdapltest_major $kdapltest_minor

