#!/bin/false -- do not execute!

#MTL-HEADER##################################################################
#                 - Mellanox Confidential and Proprietary -
#
# Copyright (C) Jan. 2004, Mellanox Technologies Ltd.  ALL RIGHTS RESERVED.
#
# Except as specifically permitted herein, no portion of the information,
# including but not limited to object code and source code, may be reproduced,
# modified, distributed, republished or otherwise exploited in any form or by
# any means for any purpose without the prior written permission of Mellanox
# Technologies Ltd. Use of software subject to the terms and conditions
# detailed in the file "LICENSE.txt".
# End of legal section.
#############################################################################
# Id ..........$Id: ibconf.tcl,v 1.12 2005/07/03 11:07:17 orenk Exp $
# Revision.....$Revision: 1.12 $
# Date.........$Date: 2005/07/03 11:07:17 $
# Author.......$Author: orenk $
#EOH#########################################################################

#
# inconf -- reads the /etc/ibadm.conf and provides defaults for the
#           non defined parameters. Supports only one interface: ibconf::get
#

namespace eval ibconf {
   global ibConfDir
   variable ConfParams
   
   # some defaults:
   proc init {} {
      global ConfParams
      global ibConfDir
      if {[catch {set f [open $ibConfDir/ibadm.conf r]}]} {
         puts "-E- Fail to open default config file: $ibConfDir/ibadm.conf"
         return
      }  
      
      while {[gets $f sLine] >= 0} {
         if {[regexp {^\s*[\#]} $sLine]} {
            continue
         } elseif {[regexp {^\s*([^\s=]+)\s*=\s*(\S+)\s*$} \
                       $sLine d1 name val]} {
            set ConfParams($name) $val
         }
      }
      close $f

      # Now try the user file...

      if {[catch {set f [open /etc/ibadm.conf r]}]} {
         return
      }  

      while {[gets $f sLine] >= 0} {
         if {[regexp {^\s*[\#]} $sLine]} {
            continue
         } elseif {[regexp {^\s*([^\s=]+)\s*=\s*(\S+)\s*$} \
                       $sLine d1 name val]} {
            set ConfParams($name) $val
         }
      }
      close $f
   }

   proc get {param} {
      global ConfParams

      if {$param == "*"} {
         return [array get ConfParams]
      } elseif {[info exists ConfParams($param)]} {
         return $ConfParams($param)
      } else {
        return UNKNOWN
      }
   }

   proc format_revision {cvs_rev_str} {
      if {[info exists ::BLD_VER]} {
	 set bld_ver $::BLD_VER
      } else {
	 set bld_ver "Developement(BLD_VER not defined)"
      }

      if {! [regexp {Revision:\s*(\d+\.\d+)} $cvs_rev_str d1 cvs_rev]} {
	 set cvs_rev "???"
      }

      return "IBADM 1.8.0 , BUILD $bld_ver , CVS $cvs_rev"
   }
}

package provide ibconf 1.0

namespace eval ibconf { 
   init
}
